Index: cpukit/score/include/rtems/score/threadqimpl.h
===================================================================
--- cpukit/score/include/rtems/score/threadqimpl.h	(revision 8118b670655308ec1a39fda3fe33db2a6b55e667)
+++ cpukit/score/include/rtems/score/threadqimpl.h	(revision 91e7b0c5ae837c055fd67d77d8db26bfb648261b)
@@ -136,11 +136,14 @@
  *  @param[in] the_thread_queue is the pointer to the ThreadQ header
  *  @param[in] the_thread is the pointer to a thread control block that is to be removed
- *
- *  @retval true The extract operation was performed by the executing context.
- *  @retval false Otherwise.
- */
-bool _Thread_queue_Extract(
+ */
+void _Thread_queue_Extract(
   Thread_queue_Control *the_thread_queue,
   Thread_Control       *the_thread
+);
+
+void _Thread_queue_Extract_with_return_code(
+  Thread_queue_Control *the_thread_queue,
+  Thread_Control       *the_thread,
+  uint32_t              return_code
 );
 
@@ -266,6 +269,7 @@
  *  @retval false Otherwise.
  */
-bool _Thread_queue_Extract_priority_helper(
+void _Thread_queue_Extract_priority_helper(
   Thread_Control       *the_thread,
+  uint32_t              return_code,
   bool                  requeuing
 );
@@ -277,6 +281,6 @@
  */
 
-#define _Thread_queue_Extract_priority( _the_thread ) \
-  _Thread_queue_Extract_priority_helper( _the_thread, false )
+#define _Thread_queue_Extract_priority( _the_thread, _return_code ) \
+  _Thread_queue_Extract_priority_helper( _the_thread, _return_code, false )
 /**
  *  @brief Get highest priority thread on the_thread_queue.
@@ -338,6 +342,7 @@
  *  and cancels any timeouts associated with this blocking.
  */
-bool _Thread_queue_Extract_fifo(
-  Thread_Control       *the_thread
+void _Thread_queue_Extract_fifo(
+  Thread_Control       *the_thread,
+  uint32_t              return_code
 );
 
Index: cpukit/score/src/threadqextract.c
===================================================================
--- cpukit/score/src/threadqextract.c	(revision 8118b670655308ec1a39fda3fe33db2a6b55e667)
+++ cpukit/score/src/threadqextract.c	(revision 91e7b0c5ae837c055fd67d77d8db26bfb648261b)
@@ -22,7 +22,8 @@
 #include <rtems/score/threadqimpl.h>
 
-bool _Thread_queue_Extract(
+void _Thread_queue_Extract_with_return_code(
   Thread_queue_Control *the_thread_queue,
-  Thread_Control       *the_thread
+  Thread_Control       *the_thread,
+  uint32_t              return_code
 )
 {
@@ -32,7 +33,19 @@
    */
   if  ( the_thread_queue->discipline == THREAD_QUEUE_DISCIPLINE_PRIORITY )
-    return _Thread_queue_Extract_priority( the_thread );
+    return _Thread_queue_Extract_priority( the_thread, return_code );
   else /* must be THREAD_QUEUE_DISCIPLINE_FIFO */
-    return _Thread_queue_Extract_fifo( the_thread );
+    return _Thread_queue_Extract_fifo( the_thread, return_code );
 
 }
+
+void _Thread_queue_Extract(
+  Thread_queue_Control *the_thread_queue,
+  Thread_Control       *the_thread
+)
+{
+  _Thread_queue_Extract_with_return_code(
+    the_thread_queue,
+    the_thread,
+    the_thread->Wait.return_code
+  );
+}
Index: cpukit/score/src/threadqextractfifo.c
===================================================================
--- cpukit/score/src/threadqextractfifo.c	(revision 8118b670655308ec1a39fda3fe33db2a6b55e667)
+++ cpukit/score/src/threadqextractfifo.c	(revision 91e7b0c5ae837c055fd67d77d8db26bfb648261b)
@@ -26,6 +26,7 @@
 #include <rtems/score/watchdogimpl.h>
 
-bool _Thread_queue_Extract_fifo(
-  Thread_Control       *the_thread
+void _Thread_queue_Extract_fifo(
+  Thread_Control       *the_thread,
+  uint32_t              return_code
 )
 {
@@ -36,5 +37,5 @@
   if ( !_States_Is_waiting_on_thread_queue( the_thread->current_state ) ) {
     _ISR_Enable( level );
-    return false;
+    return;
   }
 
@@ -42,4 +43,5 @@
 
   the_thread->Wait.queue = NULL;
+  the_thread->Wait.return_code = return_code;
 
   if ( !_Watchdog_Is_active( &the_thread->Timer ) ) {
@@ -57,5 +59,3 @@
     _Thread_MP_Free_proxy( the_thread );
 #endif
-
-  return true;
 }
Index: cpukit/score/src/threadqextractpriority.c
===================================================================
--- cpukit/score/src/threadqextractpriority.c	(revision 8118b670655308ec1a39fda3fe33db2a6b55e667)
+++ cpukit/score/src/threadqextractpriority.c	(revision 91e7b0c5ae837c055fd67d77d8db26bfb648261b)
@@ -25,6 +25,7 @@
 #include <rtems/score/watchdogimpl.h>
 
-bool _Thread_queue_Extract_priority_helper(
+void _Thread_queue_Extract_priority_helper(
   Thread_Control       *the_thread,
+  uint32_t              return_code,
   bool                  requeuing
 )
@@ -45,5 +46,5 @@
   if ( !_States_Is_waiting_on_thread_queue( the_thread->current_state ) ) {
     _ISR_Enable( level );
-    return false;
+    return;
   }
 
@@ -87,6 +88,9 @@
   if ( requeuing ) {
     _ISR_Enable( level );
-    return true;
+    return;
   }
+
+  the_thread->Wait.queue = NULL;
+  the_thread->Wait.return_code = return_code;
 
   if ( !_Watchdog_Is_active( &the_thread->Timer ) ) {
@@ -103,5 +107,3 @@
     _Thread_MP_Free_proxy( the_thread );
 #endif
-
-  return true;
 }
Index: cpukit/score/src/threadqprocesstimeout.c
===================================================================
--- cpukit/score/src/threadqprocesstimeout.c	(revision 8118b670655308ec1a39fda3fe33db2a6b55e667)
+++ cpukit/score/src/threadqprocesstimeout.c	(revision 91e7b0c5ae837c055fd67d77d8db26bfb648261b)
@@ -52,6 +52,4 @@
       _ISR_Enable( level );
     } else {
-      bool we_did_it;
-
       _ISR_Enable( level );
 
@@ -71,8 +69,9 @@
        * queue initialization.
        */
-      we_did_it = _Thread_queue_Extract( the_thread_queue, the_thread );
-      if ( we_did_it ) {
-        the_thread->Wait.return_code = the_thread_queue->timeout_status;
-      }
+      _Thread_queue_Extract_with_return_code(
+        the_thread_queue,
+        the_thread,
+        the_thread_queue->timeout_status
+      );
     }
   } else {
Index: cpukit/score/src/threadqrequeue.c
===================================================================
--- cpukit/score/src/threadqrequeue.c	(revision 8118b670655308ec1a39fda3fe33db2a6b55e667)
+++ cpukit/score/src/threadqrequeue.c	(revision 91e7b0c5ae837c055fd67d77d8db26bfb648261b)
@@ -46,5 +46,9 @@
     if ( _States_Is_waiting_on_thread_queue( the_thread->current_state ) ) {
       _Thread_queue_Enter_critical_section( tq );
-      _Thread_queue_Extract_priority_helper( the_thread, true );
+      _Thread_queue_Extract_priority_helper(
+        the_thread,
+        the_thread->Wait.return_code,
+        true
+      );
       (void) _Thread_queue_Enqueue_priority( tq, the_thread, &level_ignored );
     }
Index: testsuites/sptests/spthreadq01/init.c
===================================================================
--- testsuites/sptests/spthreadq01/init.c	(revision 8118b670655308ec1a39fda3fe33db2a6b55e667)
+++ testsuites/sptests/spthreadq01/init.c	(revision 91e7b0c5ae837c055fd67d77d8db26bfb648261b)
@@ -32,5 +32,4 @@
 {
   Thread_queue_Control tq;
-  bool we_did_it;
 
   printf( "Init - initialize thread queue for %s\n", discipline_string );
@@ -39,7 +38,6 @@
   puts( "Init - _Thread_queue_Extract - thread not blocked on a thread queue" );
   _Thread_Disable_dispatch();
-  we_did_it = _Thread_queue_Extract( &tq, _Thread_Executing );
+  _Thread_queue_Extract( &tq, _Thread_Executing );
   _Thread_Enable_dispatch();
-  rtems_test_assert( !we_did_it );
   /* is there more to check? */
 }
